=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class CustomsItem
    attr_accessor :description

    attr_accessor :eccn_ear99

    attr_accessor :mass_unit

    attr_accessor :metadata

    attr_accessor :net_weight

    attr_accessor :object_created

    attr_accessor :object_id

    attr_accessor :object_owner

    attr_accessor :object_state

    attr_accessor :object_updated

    attr_accessor :origin_country

    attr_accessor :quantity

    # The stock keeping unit value of this item.
    attr_accessor :sku_code

    attr_accessor :tariff_number

    attr_accessor :test

    attr_accessor :value_amount

    attr_accessor :value_currency

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'description' => :'description',
        :'eccn_ear99' => :'eccn_ear99',
        :'mass_unit' => :'mass_unit',
        :'metadata' => :'metadata',
        :'net_weight' => :'net_weight',
        :'object_created' => :'object_created',
        :'object_id' => :'object_id',
        :'object_owner' => :'object_owner',
        :'object_state' => :'object_state',
        :'object_updated' => :'object_updated',
        :'origin_country' => :'origin_country',
        :'quantity' => :'quantity',
        :'sku_code' => :'sku_code',
        :'tariff_number' => :'tariff_number',
        :'test' => :'test',
        :'value_amount' => :'value_amount',
        :'value_currency' => :'value_currency'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'description' => :'Object',
        :'eccn_ear99' => :'Object',
        :'mass_unit' => :'Object',
        :'metadata' => :'Object',
        :'net_weight' => :'Object',
        :'object_created' => :'Object',
        :'object_id' => :'Object',
        :'object_owner' => :'Object',
        :'object_state' => :'Object',
        :'object_updated' => :'Object',
        :'origin_country' => :'Object',
        :'quantity' => :'Object',
        :'sku_code' => :'Object',
        :'tariff_number' => :'Object',
        :'test' => :'Object',
        :'value_amount' => :'Object',
        :'value_currency' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::CustomsItem` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::CustomsItem`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'eccn_ear99')
        self.eccn_ear99 = attributes[:'eccn_ear99']
      end

      if attributes.key?(:'mass_unit')
        self.mass_unit = attributes[:'mass_unit']
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'net_weight')
        self.net_weight = attributes[:'net_weight']
      end

      if attributes.key?(:'object_created')
        self.object_created = attributes[:'object_created']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'object_owner')
        self.object_owner = attributes[:'object_owner']
      end

      if attributes.key?(:'object_state')
        self.object_state = attributes[:'object_state']
      end

      if attributes.key?(:'object_updated')
        self.object_updated = attributes[:'object_updated']
      end

      if attributes.key?(:'origin_country')
        self.origin_country = attributes[:'origin_country']
      end

      if attributes.key?(:'quantity')
        self.quantity = attributes[:'quantity']
      end

      if attributes.key?(:'sku_code')
        self.sku_code = attributes[:'sku_code']
      end

      if attributes.key?(:'tariff_number')
        self.tariff_number = attributes[:'tariff_number']
      end

      if attributes.key?(:'test')
        self.test = attributes[:'test']
      end

      if attributes.key?(:'value_amount')
        self.value_amount = attributes[:'value_amount']
      end

      if attributes.key?(:'value_currency')
        self.value_currency = attributes[:'value_currency']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @mass_unit.nil?
        invalid_properties.push('invalid value for "mass_unit", mass_unit cannot be nil.')
      end

      if @net_weight.nil?
        invalid_properties.push('invalid value for "net_weight", net_weight cannot be nil.')
      end

      if @origin_country.nil?
        invalid_properties.push('invalid value for "origin_country", origin_country cannot be nil.')
      end

      if @quantity.nil?
        invalid_properties.push('invalid value for "quantity", quantity cannot be nil.')
      end

      if @value_amount.nil?
        invalid_properties.push('invalid value for "value_amount", value_amount cannot be nil.')
      end

      if @value_currency.nil?
        invalid_properties.push('invalid value for "value_currency", value_currency cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @description.nil?
      return false if @mass_unit.nil?
      mass_unit_validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      return false unless mass_unit_validator.valid?(@mass_unit)
      return false if @net_weight.nil?
      object_state_validator = EnumAttributeValidator.new('Object', ['INVALID', 'VALID'])
      return false unless object_state_validator.valid?(@object_state)
      return false if @origin_country.nil?
      return false if @quantity.nil?
      return false if @value_amount.nil?
      return false if @value_currency.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] mass_unit Object to be assigned
    def mass_unit=(mass_unit)
      validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      unless validator.valid?(mass_unit)
        fail ArgumentError, "invalid value for \"mass_unit\", must be one of #{validator.allowable_values}."
      end
      @mass_unit = mass_unit
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] object_state Object to be assigned
    def object_state=(object_state)
      validator = EnumAttributeValidator.new('Object', ['INVALID', 'VALID'])
      unless validator.valid?(object_state)
        fail ArgumentError, "invalid value for \"object_state\", must be one of #{validator.allowable_values}."
      end
      @object_state = object_state
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          description == o.description &&
          eccn_ear99 == o.eccn_ear99 &&
          mass_unit == o.mass_unit &&
          metadata == o.metadata &&
          net_weight == o.net_weight &&
          object_created == o.object_created &&
          object_id == o.object_id &&
          object_owner == o.object_owner &&
          object_state == o.object_state &&
          object_updated == o.object_updated &&
          origin_country == o.origin_country &&
          quantity == o.quantity &&
          sku_code == o.sku_code &&
          tariff_number == o.tariff_number &&
          test == o.test &&
          value_amount == o.value_amount &&
          value_currency == o.value_currency
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [description, eccn_ear99, mass_unit, metadata, net_weight, object_created, object_id, object_owner, object_state, object_updated, origin_country, quantity, sku_code, tariff_number, test, value_amount, value_currency].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
